﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    class Program
    {
        const int N = 10000;
        static long startTick;
        static long endTick;
        static long timecalctime = 0;
        static void Main(string[] args)
        {
            startWatch();
            stopWatch();
            calculateRunTime(true);

            string result = "";
            string outp = "";
            int f;
            int b;

            startWatch();
            for (int i = 1; i <= N; ++i)
            {
                if ((i % 3 == 0) && (i % 5 == 0)) result += "FizzBuzz";
                else if (i % 3 == 0) result += "Fizz";
                else if (i % 5 == 0) result += "Buzz";
                else result += i.ToString();
                result += ", ";
            }
            stopWatch();
            printResultAndTime(result, "4 modulo, elses and int test");
            System.Threading.Thread.Sleep(1000);
            
            result = "";
            startWatch();
            for (int i = 1; i <= N; ++i)
            {
                f = i % 3;
                b = i % 5;
                if(f == 0) result += "Fizz";
                if(b == 0) result += "Buzz";
                if (f > 0 && b > 0) result += i.ToString();
                result += ", ";
            }
            stopWatch();
            printResultAndTime(result, "modulo, assignments and int test");
            System.Threading.Thread.Sleep(1000);

            result = "";
            startWatch();
            for (int i = 1; i <= N; ++i)
            {
                outp = "";
                if (i % 3 == 0) outp = "Fizz";
                if (i % 5 == 0) outp += "Buzz";
                if (outp == "") outp = i.ToString();
                result += outp + ", ";
            }
            stopWatch();
            printResultAndTime(result, "modulo and string test");
            System.Threading.Thread.Sleep(1000);

            int x = 3;
            int y = 5;
            int a = 1;
            b = N;
            int x1 = a % x;
            int y1 = a % y;
            result = "";
            startWatch();
            for (int i = a; i <= b; i++)
            {
                if (x1 == 0) result += "Fizz";
                if (y1 == 0) result += "Buzz";
                if (x1 != 0 && y1 != 0) result += i.ToString();
                result += ", ";
                x1 = (x1 == x - 1 ? 0 : x1 + 1);
                y1 = (y1 == y - 1 ? 0 : y1 + 1);
            }
            stopWatch();
            printResultAndTime(result, "single modulo, count up test");
            System.Threading.Thread.Sleep(1000);

            int fizz = 3; 
            int buzz = 5;
            result = "";
            startWatch();
            for(int i = 1; i <= N; ++i) { 
	            fizz--; 
	            buzz--;
                if (fizz == 0 && buzz == 0)
                { 
		            outp = "FizzBuzz"; 
		            fizz = 3; 
		            buzz = 5;
                }
                else if (fizz == 0)
                { 
		            outp = "Fizz"; 
		            fizz = 3;
                }
                else if (buzz == 0)
                { 
		            outp = "Buzz"; 
		            buzz = 5; 
	            } else { 
		            outp = i.ToString(); 
	            }
	            result += outp + ", ";
            }
            stopWatch();
            printResultAndTime(result, "no modulo, count down test");
            System.Threading.Thread.Sleep(1000);

            result = "";
            string[] messages = new string[]{null, "Fizz", "Buzz", "FizzBuzz"};
            int acc = 810092048; //11 00 00 01 00 10 01 00 00 01 10 00 01 00 00
            int c = 0;
            startWatch();
            for (int i=1; i <= N; ++i) 
            {
                c = acc & 3;
                result += (c > 0 ? messages[c] : i.ToString()) + ", ";
                acc = acc >> 2 | c << 28;
            }
            stopWatch();
            printResultAndTime(result, "bitwise");

            Console.ReadKey();
        }

        static void startWatch() {
            startTick = DateTime.UtcNow.Ticks;
        }

        static void stopWatch() {
            endTick = DateTime.UtcNow.Ticks;
        }

        static long calculateRunTime(bool shouldCalcTheCalcTime)
        {
            long tick;
            long microseconds;
            tick = endTick - startTick;
            microseconds = tick / 10 - timecalctime;
            if (shouldCalcTheCalcTime) timecalctime = microseconds;
            return microseconds;
        }

        static void printResultAndTime(string result, string testType)
        {
            //Console.Write("\n  " + result + "\n" + testType + " - " + String.Format("{0:0,0}µs", calculateRunTime(false)) + "\n");
            Console.Write("\n  " + testType + " - " + String.Format("{0:0,0}µs", calculateRunTime(false)) + "\n");
        }
    }
}
